
----------------------------------------------------------------
-- write by xerysherry

-- 得到基类
local Object = getClass("Object");

-- 一些简单的数据结构
local Size = class("Size", Object,
{
	-- 变量
	width = 0, height = 0,
	-- 方法
	initialize = function (this, w, h)
		this:setSize(w, h)
	end,
	getSize = function (this) 
		return this.width, this.height; 
	end,
	setSize = function (this, w, h)
		this.width, this.height = w, h;
	end,
});

local Point = class("Point", Object,
{
	-- 变量
	x = 0, y = 0,
	-- 方法
	initialize = function (this, x, y)
		this:setPoint(x, y, w, h)
	end,
	getPoint = function (this) 
		return this.x, this.y; 
	end,
	setPoint = function (this, x, y)
		this.x, this.y = x, y;
	end,
})

local Rect = class("Rect", Object,
{
	-- 变量
	x = 0, y = 0,
	width = 0, height = 0,
	-- 方法
	initialize = function (this, x, y, w, h)
		this:setRect(x, y, w, h)
	end,
	getPoint = function (this) 
		return this.x, this.y; 
	end,
	getSize = function (this) 
		return this.width, this.height; 
	end,
	getRect = function (this) 
		return this.x, this.y, this.width, this.height; 
	end,
	setRect = function (this, x, y, w, h)
		this.x, this.y, this.width, this.height = x, y, w, h;
	end,
});

function MergeRect(l, t, w, h, 
				ml, mt, mw, mh)
	local r, b = w, h;
	r = r+l;
	b = b+t;
	local mr, mb = mw, mh;
	mr = mr+ml;
	mb = mb+mt;
	local nl, nt, nr, nb = 0, 0, 0, 0;
	
	if ml <= l then
		nl = l;
	elseif ml < r then
		nl = ml;
	else
		return nil;
	end
	
	if mt <= t then
		nt = t;
	elseif mt < b then
		nt = mt;
	else
		return nil;
	end
	
	if mr < l then
		return nil;
	elseif mr < r then
		nr = mr;
	else
		nr = r;
	end
	
	if mb < t then
		return nil;
	elseif mb < b then
		nb = mb;
	else
		nb = b;
	end
	
	return nl, nt, nr-nl, nb-nt;
end

function IsPointIn(arg1, arg2, arg3)
	if arg3==nil then
		local point, rect = arg1, arg2;
		if rect.x <= point.x and point.x < rect.x+rect.width and
			rect.y <= point.y and point.y < rect.y+rect.height then
			return true;
		else
			return false;
		end
	else
		local x, y, rect = arg1, arg2, arg3;
		if rect.x <= x and x < rect.x+rect.width and
			rect.y <= y and y < rect.y+rect.height then
			return true;
		else
			return false;
		end
	end
end

