----------------------------------------------------------------
-- write by xerysherry

-- õ
local Object = getClass("Object");
local Filesystem = getClass("Object.Filesystem");

local lg = love.graphics;

-- 
local Font = class("Font", Object, 
{
	path = nil,				-- ·
	size = 0,
	font = nil,				-- love
});

-- 
local FontManager = class("FontManager", Object, 
{
	-- Ƶļϵͳ
	filesystem = nil,
	fontlist = nil,
});

----------------------------------------------------------------
-- ʼһ
function FontManager:initialize(tempdir)
	-- ʼڲļϵͳ
	self.filesystem = Filesystem:new(tempdir);
	self.fontlist = {};
	self:createFontFromSize("_system",12);
end

function FontManager:getSamePathFont(path, size)
	if path==nil then
		return nil;
	end
	
	for i,v in pairs(self.fontlist) do
		if path==v.path and size==v.size then
			return v;
		end
	end
	return nil;
end

function FontManager:createFontFromPath(idx, path, size)
	self.fontlist[idx] = self:getSamePathFont(path, size);
	if self.fontlist[idx]==nil then
		self.fontlist[idx] = Font:new();
		self.fontlist[idx].path = path;
		self.fontlist[idx].font = lg.newFont(path, size);
	end
end

function FontManager:createFontFromSize(idx, size)
	self.fontlist[idx] = self:getSamePathFont("_default", size);
	if self.fontlist[idx]==nil then
		self.fontlist[idx] = Font:new();
		self.fontlist[idx].path = "_default";
		self.fontlist[idx].font = lg.newFont(size);
	end
end

function FontManager:createFontFromPathPlus(idx, path, size)
	local path = self.filesystem:createTempFromPath(idx, path);
	self:createFontFromPath(idx, path, size);
end

-- 
function FontManager:getFont(idx)
	local f = self.fontlist[idx];
	if f==nil then
		return nil;
	end
	return f.font;
end

-- 
function FontManager:setFont(idx)
	local f = self.fontlist[idx];
	if f then
		lg.setFont(f.font);
	end
end

FontManager._print = lg.print;
FontManager._printf = lg.printf;

return FontManager;
