
----------------------------------------------------------------
-- write by xerysherry

local lj = love.joystick;

-- 得到基类
local Object = getClass("Object");

-- 手柄回调处理类
local Joystick = class("Joystick", Object,
{
	-- 按下回调
	onPressed = function (joystick, button) end,
	-- 抬起回调
	onReleased = function (joystick, button) end,
});

function Joystick:pressed(joystick, button)
	self.onPressed(joystick, button);
end

function Joystick:released(joystick, button)
	self.onReleased(joystick, button);
end

----------------------------------------------------------------
-- 直接获取love.joystick的方法
Joystick._close = lj.close;
Joystick._getAxes = lj.getAxes;
Joystick._getAxis = lj.getAxis;
Joystick._getBall = lj.getBall;
Joystick._getHat = lj.getHat;
Joystick._getName = lj.getName;
Joystick._getNumAxes = lj.getNumAxes;
Joystick._getNumBalls = lj.getNumBalls;
Joystick._getNumButtons = lj.getNumButtons;
Joystick._getNumHats = lj.getNumHats;
Joystick._getNumJoysticks = lj.getNumJoysticks;
Joystick._isDown = lj.isDown;
Joystick._isOpen = lj.isOpen;
Joystick._open = lj.open;

return Joystick;
