
----------------------------------------------------------------
-- write by xerysherry

local lk = love.keyboard

-- 得到基类
local Object = getClass("Object");

-- 键盘回调处理类
local Keyboard = class("Keyboard", Object,
{
	-- 输入字符回调事件函数
	onChar = function (char) end,
	-- 按下键盘回调事件函数
	onPressed = function (key) end,
	-- 释放键盘回调事件函数
	onReleased = function (key) end,
});

function Keyboard:pressed(key, unicode)
	self.onPressed(key);
	if unicode~=0 then
		--非0清空下表示为可记录字符
		--注意：退格符，回车符，制表符是可以记录字符，请在onChar回调中处理之
		self.onChar(string.char(unicode));
	end
end

function Keyboard:released(key)
	self.onReleased(key);
end

----------------------------------------------------------------
-- 直接获取love.keyboard的方法
Keyboard._getKeyRepeat = lk.getKeyRepeat;
Keyboard._setKeyRepeat = lk.setKeyRepeat;
Keyboard._isDown = lk.isDown;

return Keyboard;
